package exnihilocreatio.tiles;

import exnihilocreatio.blocks.BlockInfestingLeaves;
import exnihilocreatio.config.ModConfig;
import exnihilocreatio.networking.PacketHandler;
import exnihilocreatio.util.BlockInfo;
import lombok.Getter;
import net.minecraft.block.Block;
import net.minecraft.block.state.IBlockState;
import net.minecraft.init.Blocks;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.ITickable;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

import javax.annotation.Nonnull;

public class TileInfestingLeaves extends BaseTileEntity implements ITickable, ITileLeafBlock {
    @Getter
    private int progress = 0;
    @Getter
    private IBlockState leafBlock = Blocks.field_150362_t.func_176223_P();

    private int doProgress = (int) (ModConfig.infested_leaves.ticksToTransform / 100.0);
    private int spreadCounter = 0;

    @Override
    public void func_73660_a() {
        if (!field_145850_b.field_72995_K) {
            if (doProgress <= 0) {
                progress++;
                spreadCounter++;
                if (progress >= 100) {
                    BlockInfestingLeaves.setInfested(field_145850_b, field_174879_c, leafBlock);
                    markDirtyClient();
                }

                if (spreadCounter >= ModConfig.infested_leaves.leavesUpdateFrequency) {
                    BlockInfestingLeaves.spread(field_145850_b, field_174879_c, field_145850_b.func_180495_p(field_174879_c), field_145850_b.field_73012_v);
                    spreadCounter = 0;
                }

                doProgress = (int) (ModConfig.infested_leaves.ticksToTransform / 100.0);

                //Send packet at the end incase the block gets changed first.
                PacketHandler.sendNBTUpdate(this);
            } else {
                doProgress--;
            }
        }
    }

    @Override
    public boolean shouldRefresh(World world, BlockPos pos, @Nonnull IBlockState oldState, @Nonnull IBlockState newState) {
        return oldState.func_177230_c() != newState.func_177230_c();
    }

    @Override
    @Nonnull
    public AxisAlignedBB getRenderBoundingBox() {
        return INFINITE_EXTENT_AABB;
    }

    public void setProgress(int newProgress) {
        progress = newProgress;
        PacketHandler.sendNBTUpdate(this);
    }

    public void setLeafBlock(IBlockState block) {
        leafBlock = block;
        PacketHandler.sendNBTUpdate(this);
    }

    @Override
    @Nonnull
    public NBTTagCompound func_189515_b(NBTTagCompound tag) {
        tag = super.func_189515_b(tag);
        tag.func_74768_a("progress", progress);
        tag.func_74778_a("leafBlock", leafBlock.func_177230_c().getRegistryName() == null ? "" : leafBlock.func_177230_c().getRegistryName().toString());
        tag.func_74768_a("leafBlockMeta", leafBlock.func_177230_c().func_176201_c(leafBlock));
        return tag;
    }

    @SuppressWarnings("deprecation")
    @Override
    public void func_145839_a(NBTTagCompound tag) {
        super.func_145839_a(tag);
        progress = tag.func_74762_e("progress");

        if (tag.func_74764_b("leafBlock") && tag.func_74764_b("leafBlockMeta")) {
            BlockInfo leaves = new BlockInfo(Block.func_149684_b(tag.func_74779_i("leafBlock")), tag.func_74762_e("leafBlockMeta"));
            if (leaves.isValid())
                leafBlock = leaves.getBlockState();
            else leafBlock = Blocks.field_150362_t.func_176223_P();
        } else {
            leafBlock = Blocks.field_150362_t.func_176223_P();
        }
    }

    @Override
    public boolean hasFastRenderer() {
        return true;
    }
}
